-----------------------------------------------------------------------
--  AWA.Blogs.Models -- AWA.Blogs.Models
-----------------------------------------------------------------------
--  File generated by ada-gen DO NOT MODIFY
--  Template used: templates/model/package-body.xhtml
--  Ada Generator: https://ada-gen.googlecode.com/svn/trunk Revision 1095
-----------------------------------------------------------------------
--  Copyright (C) 2020 Stephane Carrez
--  Written by Stephane Carrez (Stephane.Carrez@gmail.com)
--
--  Licensed under the Apache License, Version 2.0 (the "License");
--  you may not use this file except in compliance with the License.
--  You may obtain a copy of the License at
--
--      http://www.apache.org/licenses/LICENSE-2.0
--
--  Unless required by applicable law or agreed to in writing, software
--  distributed under the License is distributed on an "AS IS" BASIS,
--  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
--  See the License for the specific language governing permissions and
--  limitations under the License.
-----------------------------------------------------------------------
with Ada.Unchecked_Deallocation;
with Util.Beans.Objects.Time;
with ASF.Events.Faces.Actions;
with AWA.Events.Action_Method;
package body AWA.Blogs.Models is

   use type ADO.Objects.Object_Record_Access;
   use type ADO.Objects.Object_Ref;

   pragma Warnings (Off, "formal parameter * is not referenced");

   function Blog_Key (Id : in ADO.Identifier) return ADO.Objects.Object_Key is
      Result : ADO.Objects.Object_Key (Of_Type  => ADO.Objects.KEY_INTEGER,
                                       Of_Class => BLOG_DEF'Access);
   begin
      ADO.Objects.Set_Value (Result, Id);
      return Result;
   end Blog_Key;

   function Blog_Key (Id : in String) return ADO.Objects.Object_Key is
      Result : ADO.Objects.Object_Key (Of_Type  => ADO.Objects.KEY_INTEGER,
                                       Of_Class => BLOG_DEF'Access);
   begin
      ADO.Objects.Set_Value (Result, Id);
      return Result;
   end Blog_Key;

   function "=" (Left, Right : Blog_Ref'Class) return Boolean is
   begin
      return ADO.Objects.Object_Ref'Class (Left) = ADO.Objects.Object_Ref'Class (Right);
   end "=";

   procedure Set_Field (Object : in out Blog_Ref'Class;
                        Impl   : out Blog_Access) is
      Result : ADO.Objects.Object_Record_Access;
   begin
      Object.Prepare_Modify (Result);
      Impl := Blog_Impl (Result.all)'Access;
   end Set_Field;

   --  Internal method to allocate the Object_Record instance
   procedure Allocate (Object : in out Blog_Ref) is
      Impl : Blog_Access;
   begin
      Impl := new Blog_Impl;
      Impl.Version := 0;
      Impl.Create_Date := ADO.DEFAULT_TIME;
      Impl.Update_Date := ADO.DEFAULT_TIME;
      Impl.Format := AWA.Blogs.Models.Format_Type'First;
      ADO.Objects.Set_Object (Object, Impl.all'Access);
   end Allocate;

   -- ----------------------------------------
   --  Data object: Blog
   -- ----------------------------------------

   procedure Set_Id (Object : in out Blog_Ref;
                     Value  : in ADO.Identifier) is
      Impl : Blog_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_Key_Value (Impl.all, 1, Value);
   end Set_Id;

   function Get_Id (Object : in Blog_Ref)
                  return ADO.Identifier is
      Impl : constant Blog_Access
         := Blog_Impl (Object.Get_Object.all)'Access;
   begin
      return Impl.Get_Key_Value;
   end Get_Id;


   procedure Set_Name (Object : in out Blog_Ref;
                        Value : in String) is
      Impl : Blog_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Audits.Set_Field_String (Impl.all, 2, Impl.Name, Value);
   end Set_Name;

   procedure Set_Name (Object : in out Blog_Ref;
                       Value  : in Ada.Strings.Unbounded.Unbounded_String) is
      Impl : Blog_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Audits.Set_Field_Unbounded_String (Impl.all, 2, Impl.Name, Value);
   end Set_Name;

   function Get_Name (Object : in Blog_Ref)
                 return String is
   begin
      return Ada.Strings.Unbounded.To_String (Object.Get_Name);
   end Get_Name;
   function Get_Name (Object : in Blog_Ref)
                  return Ada.Strings.Unbounded.Unbounded_String is
      Impl : constant Blog_Access
         := Blog_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Name;
   end Get_Name;


   function Get_Version (Object : in Blog_Ref)
                  return Integer is
      Impl : constant Blog_Access
         := Blog_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Version;
   end Get_Version;


   procedure Set_Uid (Object : in out Blog_Ref;
                       Value : in String) is
      Impl : Blog_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Audits.Set_Field_String (Impl.all, 4, Impl.Uid, Value);
   end Set_Uid;

   procedure Set_Uid (Object : in out Blog_Ref;
                      Value  : in Ada.Strings.Unbounded.Unbounded_String) is
      Impl : Blog_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Audits.Set_Field_Unbounded_String (Impl.all, 4, Impl.Uid, Value);
   end Set_Uid;

   function Get_Uid (Object : in Blog_Ref)
                 return String is
   begin
      return Ada.Strings.Unbounded.To_String (Object.Get_Uid);
   end Get_Uid;
   function Get_Uid (Object : in Blog_Ref)
                  return Ada.Strings.Unbounded.Unbounded_String is
      Impl : constant Blog_Access
         := Blog_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Uid;
   end Get_Uid;


   procedure Set_Create_Date (Object : in out Blog_Ref;
                              Value  : in Ada.Calendar.Time) is
      Impl : Blog_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_Time (Impl.all, 5, Impl.Create_Date, Value);
   end Set_Create_Date;

   function Get_Create_Date (Object : in Blog_Ref)
                  return Ada.Calendar.Time is
      Impl : constant Blog_Access
         := Blog_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Create_Date;
   end Get_Create_Date;


   procedure Set_Update_Date (Object : in out Blog_Ref;
                              Value  : in Ada.Calendar.Time) is
      Impl : Blog_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_Time (Impl.all, 6, Impl.Update_Date, Value);
   end Set_Update_Date;

   function Get_Update_Date (Object : in Blog_Ref)
                  return Ada.Calendar.Time is
      Impl : constant Blog_Access
         := Blog_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Update_Date;
   end Get_Update_Date;


   procedure Set_Url (Object : in out Blog_Ref;
                       Value : in String) is
      Impl : Blog_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Audits.Set_Field_String (Impl.all, 7, Impl.Url, Value);
   end Set_Url;

   procedure Set_Url (Object : in out Blog_Ref;
                      Value  : in Ada.Strings.Unbounded.Unbounded_String) is
      Impl : Blog_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Audits.Set_Field_Unbounded_String (Impl.all, 7, Impl.Url, Value);
   end Set_Url;

   function Get_Url (Object : in Blog_Ref)
                 return String is
   begin
      return Ada.Strings.Unbounded.To_String (Object.Get_Url);
   end Get_Url;
   function Get_Url (Object : in Blog_Ref)
                  return Ada.Strings.Unbounded.Unbounded_String is
      Impl : constant Blog_Access
         := Blog_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Url;
   end Get_Url;


   procedure Set_Format (Object : in out Blog_Ref;
                         Value  : in AWA.Blogs.Models.Format_Type) is
      procedure Set_Field_Enum is
         new ADO.Audits.Set_Field_Operation (Format_Type,
                                             Format_Type_Objects.To_Object);
      Impl : Blog_Access;
   begin
      Set_Field (Object, Impl);
      Set_Field_Enum (Impl.all, 8, Impl.Format, Value);
   end Set_Format;

   function Get_Format (Object : in Blog_Ref)
                  return AWA.Blogs.Models.Format_Type is
      Impl : constant Blog_Access
         := Blog_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Format;
   end Get_Format;


   procedure Set_Default_Image_Url (Object : in out Blog_Ref;
                                     Value : in String) is
      Impl : Blog_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Audits.Set_Field_String (Impl.all, 9, Impl.Default_Image_Url, Value);
   end Set_Default_Image_Url;

   procedure Set_Default_Image_Url (Object : in out Blog_Ref;
                                    Value  : in Ada.Strings.Unbounded.Unbounded_String) is
      Impl : Blog_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Audits.Set_Field_Unbounded_String (Impl.all, 9, Impl.Default_Image_Url, Value);
   end Set_Default_Image_Url;

   function Get_Default_Image_Url (Object : in Blog_Ref)
                 return String is
   begin
      return Ada.Strings.Unbounded.To_String (Object.Get_Default_Image_Url);
   end Get_Default_Image_Url;
   function Get_Default_Image_Url (Object : in Blog_Ref)
                  return Ada.Strings.Unbounded.Unbounded_String is
      Impl : constant Blog_Access
         := Blog_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Default_Image_Url;
   end Get_Default_Image_Url;


   procedure Set_Workspace (Object : in out Blog_Ref;
                            Value  : in AWA.Workspaces.Models.Workspace_Ref'Class) is
      Impl : Blog_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_Object (Impl.all, 10, Impl.Workspace, Value);
   end Set_Workspace;

   function Get_Workspace (Object : in Blog_Ref)
                  return AWA.Workspaces.Models.Workspace_Ref'Class is
      Impl : constant Blog_Access
         := Blog_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Workspace;
   end Get_Workspace;

   --  Copy of the object.
   procedure Copy (Object : in Blog_Ref;
                   Into   : in out Blog_Ref) is
      Result : Blog_Ref;
   begin
      if not Object.Is_Null then
         declare
            Impl : constant Blog_Access
              := Blog_Impl (Object.Get_Load_Object.all)'Access;
            Copy : constant Blog_Access
              := new Blog_Impl;
         begin
            ADO.Objects.Set_Object (Result, Copy.all'Access);
            Copy.Copy (Impl.all);
            Copy.Name := Impl.Name;
            Copy.Version := Impl.Version;
            Copy.Uid := Impl.Uid;
            Copy.Create_Date := Impl.Create_Date;
            Copy.Update_Date := Impl.Update_Date;
            Copy.Url := Impl.Url;
            Copy.Format := Impl.Format;
            Copy.Default_Image_Url := Impl.Default_Image_Url;
            Copy.Workspace := Impl.Workspace;
         end;
      end if;
      Into := Result;
   end Copy;

   procedure Find (Object  : in out Blog_Ref;
                   Session : in out ADO.Sessions.Session'Class;
                   Query   : in ADO.SQL.Query'Class;
                   Found   : out Boolean) is
      Impl  : constant Blog_Access := new Blog_Impl;
   begin
      Impl.Find (Session, Query, Found);
      if Found then
         ADO.Objects.Set_Object (Object, Impl.all'Access);
      else
         ADO.Objects.Set_Object (Object, null);
         Destroy (Impl);
      end if;
   end Find;

   procedure Load (Object  : in out Blog_Ref;
                   Session : in out ADO.Sessions.Session'Class;
                   Id      : in ADO.Identifier) is
      Impl  : constant Blog_Access := new Blog_Impl;
      Found : Boolean;
      Query : ADO.SQL.Query;
   begin
      Query.Bind_Param (Position => 1, Value => Id);
      Query.Set_Filter ("id = ?");
      Impl.Find (Session, Query, Found);
      if not Found then
         Destroy (Impl);
         raise ADO.Objects.NOT_FOUND;
      end if;
      ADO.Objects.Set_Object (Object, Impl.all'Access);
   end Load;

   procedure Load (Object  : in out Blog_Ref;
                   Session : in out ADO.Sessions.Session'Class;
                   Id      : in ADO.Identifier;
                   Found   : out Boolean) is
      Impl  : constant Blog_Access := new Blog_Impl;
      Query : ADO.SQL.Query;
   begin
      Query.Bind_Param (Position => 1, Value => Id);
      Query.Set_Filter ("id = ?");
      Impl.Find (Session, Query, Found);
      if not Found then
         Destroy (Impl);
      else
         ADO.Objects.Set_Object (Object, Impl.all'Access);
      end if;
   end Load;

   procedure Save (Object  : in out Blog_Ref;
                   Session : in out ADO.Sessions.Master_Session'Class) is
      Impl : ADO.Objects.Object_Record_Access := Object.Get_Object;
   begin
      if Impl = null then
         Impl := new Blog_Impl;
         ADO.Objects.Set_Object (Object, Impl);
      end if;
      if not ADO.Objects.Is_Created (Impl.all) then
         Impl.Create (Session);
      else
         Impl.Save (Session);
      end if;
   end Save;

   procedure Delete (Object  : in out Blog_Ref;
                     Session : in out ADO.Sessions.Master_Session'Class) is
      Impl : constant ADO.Objects.Object_Record_Access := Object.Get_Object;
   begin
      if Impl /= null then
         Impl.Delete (Session);
      end if;
   end Delete;

   --  --------------------
   --  Free the object
   --  --------------------
   procedure Destroy (Object : access Blog_Impl) is
      type Blog_Impl_Ptr is access all Blog_Impl;
      procedure Unchecked_Free is new Ada.Unchecked_Deallocation
              (Blog_Impl, Blog_Impl_Ptr);
      pragma Warnings (Off, "*redundant conversion*");
      Ptr : Blog_Impl_Ptr := Blog_Impl (Object.all)'Access;
      pragma Warnings (On, "*redundant conversion*");
   begin
      Unchecked_Free (Ptr);
   end Destroy;

   procedure Find (Object  : in out Blog_Impl;
                   Session : in out ADO.Sessions.Session'Class;
                   Query   : in ADO.SQL.Query'Class;
                   Found   : out Boolean) is
      Stmt : ADO.Statements.Query_Statement
          := Session.Create_Statement (Query, BLOG_DEF'Access);
   begin
      Stmt.Execute;
      if Stmt.Has_Elements then
         Object.Load (Stmt, Session);
         Stmt.Next;
         Found := not Stmt.Has_Elements;
      else
         Found := False;
      end if;
   end Find;

   overriding
   procedure Load (Object  : in out Blog_Impl;
                   Session : in out ADO.Sessions.Session'Class) is
      Found : Boolean;
      Query : ADO.SQL.Query;
      Id    : constant ADO.Identifier := Object.Get_Key_Value;
   begin
      Query.Bind_Param (Position => 1, Value => Id);
      Query.Set_Filter ("id = ?");
      Object.Find (Session, Query, Found);
      if not Found then
         raise ADO.Objects.NOT_FOUND;
      end if;
   end Load;

   procedure Save (Object  : in out Blog_Impl;
                   Session : in out ADO.Sessions.Master_Session'Class) is
      Stmt : ADO.Statements.Update_Statement
         := Session.Create_Statement (BLOG_DEF'Access);
   begin
      if Object.Is_Modified (1) then
         Stmt.Save_Field (Name  => COL_0_1_NAME, --  id
                          Value => Object.Get_Key);
         Object.Clear_Modified (1);
      end if;
      if Object.Is_Modified (2) then
         Stmt.Save_Field (Name  => COL_1_1_NAME, --  name
                          Value => Object.Name);
         Object.Clear_Modified (2);
      end if;
      if Object.Is_Modified (4) then
         Stmt.Save_Field (Name  => COL_3_1_NAME, --  uid
                          Value => Object.Uid);
         Object.Clear_Modified (4);
      end if;
      if Object.Is_Modified (5) then
         Stmt.Save_Field (Name  => COL_4_1_NAME, --  create_date
                          Value => Object.Create_Date);
         Object.Clear_Modified (5);
      end if;
      if Object.Is_Modified (6) then
         Stmt.Save_Field (Name  => COL_5_1_NAME, --  update_date
                          Value => Object.Update_Date);
         Object.Clear_Modified (6);
      end if;
      if Object.Is_Modified (7) then
         Stmt.Save_Field (Name  => COL_6_1_NAME, --  url
                          Value => Object.Url);
         Object.Clear_Modified (7);
      end if;
      if Object.Is_Modified (8) then
         Stmt.Save_Field (Name  => COL_7_1_NAME, --  format
                          Value => Integer (Format_Type'Pos (Object.Format)));
         Object.Clear_Modified (8);
      end if;
      if Object.Is_Modified (9) then
         Stmt.Save_Field (Name  => COL_8_1_NAME, --  default_image_url
                          Value => Object.Default_Image_Url);
         Object.Clear_Modified (9);
      end if;
      if Object.Is_Modified (10) then
         Stmt.Save_Field (Name  => COL_9_1_NAME, --  workspace_id
                          Value => Object.Workspace);
         Object.Clear_Modified (10);
      end if;
      if Stmt.Has_Save_Fields then
         Object.Version := Object.Version + 1;
         Stmt.Save_Field (Name  => "version",
                          Value => Object.Version);
         Stmt.Set_Filter (Filter => "id = ? and version = ?");
         Stmt.Add_Param (Value => Object.Get_Key);
         Stmt.Add_Param (Value => Object.Version - 1);
         declare
            Result : Integer;
         begin
            Stmt.Execute (Result);
            if Result /= 1 then
               if Result /= 0 then
                  raise ADO.Objects.UPDATE_ERROR;
               else
                  raise ADO.Objects.LAZY_LOCK;
               end if;
            end if;
            ADO.Audits.Save (Object, Session);
         end;
      end if;
   end Save;

   procedure Create (Object  : in out Blog_Impl;
                     Session : in out ADO.Sessions.Master_Session'Class) is
      Query : ADO.Statements.Insert_Statement
                  := Session.Create_Statement (BLOG_DEF'Access);
      Result : Integer;
   begin
      Object.Version := 1;
      Session.Allocate (Id => Object);
      Query.Save_Field (Name  => COL_0_1_NAME, --  id
                        Value => Object.Get_Key);
      Query.Save_Field (Name  => COL_1_1_NAME, --  name
                        Value => Object.Name);
      Query.Save_Field (Name  => COL_2_1_NAME, --  version
                        Value => Object.Version);
      Query.Save_Field (Name  => COL_3_1_NAME, --  uid
                        Value => Object.Uid);
      Query.Save_Field (Name  => COL_4_1_NAME, --  create_date
                        Value => Object.Create_Date);
      Query.Save_Field (Name  => COL_5_1_NAME, --  update_date
                        Value => Object.Update_Date);
      Query.Save_Field (Name  => COL_6_1_NAME, --  url
                        Value => Object.Url);
      Query.Save_Field (Name  => COL_7_1_NAME, --  format
                        Value => Integer (Format_Type'Pos (Object.Format)));
      Query.Save_Field (Name  => COL_8_1_NAME, --  default_image_url
                        Value => Object.Default_Image_Url);
      Query.Save_Field (Name  => COL_9_1_NAME, --  workspace_id
                        Value => Object.Workspace);
      Query.Execute (Result);
      if Result /= 1 then
         raise ADO.Objects.INSERT_ERROR;
      end if;
      ADO.Objects.Set_Created (Object);
      ADO.Audits.Save (Object, Session);
   end Create;

   procedure Delete (Object  : in out Blog_Impl;
                     Session : in out ADO.Sessions.Master_Session'Class) is
      Stmt : ADO.Statements.Delete_Statement
         := Session.Create_Statement (BLOG_DEF'Access);
   begin
      Stmt.Set_Filter (Filter => "id = ?");
      Stmt.Add_Param (Value => Object.Get_Key);
      Stmt.Execute;
   end Delete;

   --  ------------------------------
   --  Get the bean attribute identified by the name.
   --  ------------------------------
   overriding
   function Get_Value (From : in Blog_Ref;
                       Name : in String) return Util.Beans.Objects.Object is
      Obj  : ADO.Objects.Object_Record_Access;
      Impl : access Blog_Impl;
   begin
      if From.Is_Null then
         return Util.Beans.Objects.Null_Object;
      end if;
      Obj := From.Get_Load_Object;
      Impl := Blog_Impl (Obj.all)'Access;
      if Name = "id" then
         return ADO.Objects.To_Object (Impl.Get_Key);
      elsif Name = "name" then
         return Util.Beans.Objects.To_Object (Impl.Name);
      elsif Name = "uid" then
         return Util.Beans.Objects.To_Object (Impl.Uid);
      elsif Name = "create_date" then
         return Util.Beans.Objects.Time.To_Object (Impl.Create_Date);
      elsif Name = "update_date" then
         return Util.Beans.Objects.Time.To_Object (Impl.Update_Date);
      elsif Name = "url" then
         return Util.Beans.Objects.To_Object (Impl.Url);
      elsif Name = "format" then
         return AWA.Blogs.Models.Format_Type_Objects.To_Object (Impl.Format);
      elsif Name = "default_image_url" then
         return Util.Beans.Objects.To_Object (Impl.Default_Image_Url);
      end if;
      return Util.Beans.Objects.Null_Object;
   end Get_Value;


   procedure List (Object  : in out Blog_Vector;
                   Session : in out ADO.Sessions.Session'Class;
                   Query   : in ADO.SQL.Query'Class) is
      Stmt : ADO.Statements.Query_Statement
        := Session.Create_Statement (Query, BLOG_DEF'Access);
   begin
      Stmt.Execute;
      Blog_Vectors.Clear (Object);
      while Stmt.Has_Elements loop
         declare
            Item : Blog_Ref;
            Impl : constant Blog_Access := new Blog_Impl;
         begin
            Impl.Load (Stmt, Session);
            ADO.Objects.Set_Object (Item, Impl.all'Access);
            Object.Append (Item);
         end;
         Stmt.Next;
      end loop;
   end List;

   --  ------------------------------
   --  Load the object from current iterator position
   --  ------------------------------
   procedure Load (Object  : in out Blog_Impl;
                   Stmt    : in out ADO.Statements.Query_Statement'Class;
                   Session : in out ADO.Sessions.Session'Class) is
   begin
      Object.Set_Key_Value (Stmt.Get_Identifier (0));
      Object.Name := Stmt.Get_Unbounded_String (1);
      Object.Uid := Stmt.Get_Unbounded_String (3);
      Object.Create_Date := Stmt.Get_Time (4);
      Object.Update_Date := Stmt.Get_Time (5);
      Object.Url := Stmt.Get_Unbounded_String (6);
      Object.Format := Format_Type'Val (Stmt.Get_Integer (7));
      Object.Default_Image_Url := Stmt.Get_Unbounded_String (8);
      if not Stmt.Is_Null (9) then
         Object.Workspace.Set_Key_Value (Stmt.Get_Identifier (9), Session);
      end if;
      Object.Version := Stmt.Get_Integer (2);
      ADO.Objects.Set_Created (Object);
   end Load;
   function Post_Key (Id : in ADO.Identifier) return ADO.Objects.Object_Key is
      Result : ADO.Objects.Object_Key (Of_Type  => ADO.Objects.KEY_INTEGER,
                                       Of_Class => POST_DEF'Access);
   begin
      ADO.Objects.Set_Value (Result, Id);
      return Result;
   end Post_Key;

   function Post_Key (Id : in String) return ADO.Objects.Object_Key is
      Result : ADO.Objects.Object_Key (Of_Type  => ADO.Objects.KEY_INTEGER,
                                       Of_Class => POST_DEF'Access);
   begin
      ADO.Objects.Set_Value (Result, Id);
      return Result;
   end Post_Key;

   function "=" (Left, Right : Post_Ref'Class) return Boolean is
   begin
      return ADO.Objects.Object_Ref'Class (Left) = ADO.Objects.Object_Ref'Class (Right);
   end "=";

   procedure Set_Field (Object : in out Post_Ref'Class;
                        Impl   : out Post_Access) is
      Result : ADO.Objects.Object_Record_Access;
   begin
      Object.Prepare_Modify (Result);
      Impl := Post_Impl (Result.all)'Access;
   end Set_Field;

   --  Internal method to allocate the Object_Record instance
   procedure Allocate (Object : in out Post_Ref) is
      Impl : Post_Access;
   begin
      Impl := new Post_Impl;
      Impl.Create_Date := ADO.DEFAULT_TIME;
      Impl.Version := 0;
      Impl.Publish_Date.Is_Null := True;
      Impl.Status := AWA.Blogs.Models.Post_Status_Type'First;
      Impl.Allow_Comments := False;
      Impl.Read_Count := 0;
      Impl.Format := AWA.Blogs.Models.Format_Type'First;
      ADO.Objects.Set_Object (Object, Impl.all'Access);
   end Allocate;

   -- ----------------------------------------
   --  Data object: Post
   -- ----------------------------------------

   procedure Set_Id (Object : in out Post_Ref;
                     Value  : in ADO.Identifier) is
      Impl : Post_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_Key_Value (Impl.all, 1, Value);
   end Set_Id;

   function Get_Id (Object : in Post_Ref)
                  return ADO.Identifier is
      Impl : constant Post_Access
         := Post_Impl (Object.Get_Object.all)'Access;
   begin
      return Impl.Get_Key_Value;
   end Get_Id;


   procedure Set_Title (Object : in out Post_Ref;
                         Value : in String) is
      Impl : Post_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Audits.Set_Field_String (Impl.all, 2, Impl.Title, Value);
   end Set_Title;

   procedure Set_Title (Object : in out Post_Ref;
                        Value  : in Ada.Strings.Unbounded.Unbounded_String) is
      Impl : Post_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Audits.Set_Field_Unbounded_String (Impl.all, 2, Impl.Title, Value);
   end Set_Title;

   function Get_Title (Object : in Post_Ref)
                 return String is
   begin
      return Ada.Strings.Unbounded.To_String (Object.Get_Title);
   end Get_Title;
   function Get_Title (Object : in Post_Ref)
                  return Ada.Strings.Unbounded.Unbounded_String is
      Impl : constant Post_Access
         := Post_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Title;
   end Get_Title;


   procedure Set_Text (Object : in out Post_Ref;
                        Value : in String) is
      Impl : Post_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_String (Impl.all, 3, Impl.Text, Value);
   end Set_Text;

   procedure Set_Text (Object : in out Post_Ref;
                       Value  : in Ada.Strings.Unbounded.Unbounded_String) is
      Impl : Post_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_Unbounded_String (Impl.all, 3, Impl.Text, Value);
   end Set_Text;

   function Get_Text (Object : in Post_Ref)
                 return String is
   begin
      return Ada.Strings.Unbounded.To_String (Object.Get_Text);
   end Get_Text;
   function Get_Text (Object : in Post_Ref)
                  return Ada.Strings.Unbounded.Unbounded_String is
      Impl : constant Post_Access
         := Post_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Text;
   end Get_Text;


   procedure Set_Create_Date (Object : in out Post_Ref;
                              Value  : in Ada.Calendar.Time) is
      Impl : Post_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_Time (Impl.all, 4, Impl.Create_Date, Value);
   end Set_Create_Date;

   function Get_Create_Date (Object : in Post_Ref)
                  return Ada.Calendar.Time is
      Impl : constant Post_Access
         := Post_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Create_Date;
   end Get_Create_Date;


   procedure Set_Uri (Object : in out Post_Ref;
                       Value : in String) is
      Impl : Post_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Audits.Set_Field_String (Impl.all, 5, Impl.Uri, Value);
   end Set_Uri;

   procedure Set_Uri (Object : in out Post_Ref;
                      Value  : in Ada.Strings.Unbounded.Unbounded_String) is
      Impl : Post_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Audits.Set_Field_Unbounded_String (Impl.all, 5, Impl.Uri, Value);
   end Set_Uri;

   function Get_Uri (Object : in Post_Ref)
                 return String is
   begin
      return Ada.Strings.Unbounded.To_String (Object.Get_Uri);
   end Get_Uri;
   function Get_Uri (Object : in Post_Ref)
                  return Ada.Strings.Unbounded.Unbounded_String is
      Impl : constant Post_Access
         := Post_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Uri;
   end Get_Uri;


   function Get_Version (Object : in Post_Ref)
                  return Integer is
      Impl : constant Post_Access
         := Post_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Version;
   end Get_Version;


   procedure Set_Publish_Date (Object : in out Post_Ref;
                               Value  : in ADO.Nullable_Time) is
      Impl : Post_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Audits.Set_Field_Time (Impl.all, 7, Impl.Publish_Date, Value);
   end Set_Publish_Date;

   function Get_Publish_Date (Object : in Post_Ref)
                  return ADO.Nullable_Time is
      Impl : constant Post_Access
         := Post_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Publish_Date;
   end Get_Publish_Date;


   procedure Set_Status (Object : in out Post_Ref;
                         Value  : in AWA.Blogs.Models.Post_Status_Type) is
      procedure Set_Field_Enum is
         new ADO.Audits.Set_Field_Operation (Post_Status_Type,
                                             Post_Status_Type_Objects.To_Object);
      Impl : Post_Access;
   begin
      Set_Field (Object, Impl);
      Set_Field_Enum (Impl.all, 8, Impl.Status, Value);
   end Set_Status;

   function Get_Status (Object : in Post_Ref)
                  return AWA.Blogs.Models.Post_Status_Type is
      Impl : constant Post_Access
         := Post_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Status;
   end Get_Status;


   procedure Set_Allow_Comments (Object : in out Post_Ref;
                                 Value  : in Boolean) is
      Impl : Post_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Audits.Set_Field_Boolean (Impl.all, 9, Impl.Allow_Comments, Value);
   end Set_Allow_Comments;

   function Get_Allow_Comments (Object : in Post_Ref)
                  return Boolean is
      Impl : constant Post_Access
         := Post_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Allow_Comments;
   end Get_Allow_Comments;


   procedure Set_Read_Count (Object : in out Post_Ref;
                             Value  : in Integer) is
      Impl : Post_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_Integer (Impl.all, 10, Impl.Read_Count, Value);
   end Set_Read_Count;

   function Get_Read_Count (Object : in Post_Ref)
                  return Integer is
      Impl : constant Post_Access
         := Post_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Read_Count;
   end Get_Read_Count;


   procedure Set_Summary (Object : in out Post_Ref;
                           Value : in String) is
      Impl : Post_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Audits.Set_Field_String (Impl.all, 11, Impl.Summary, Value);
   end Set_Summary;

   procedure Set_Summary (Object : in out Post_Ref;
                          Value  : in Ada.Strings.Unbounded.Unbounded_String) is
      Impl : Post_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Audits.Set_Field_Unbounded_String (Impl.all, 11, Impl.Summary, Value);
   end Set_Summary;

   function Get_Summary (Object : in Post_Ref)
                 return String is
   begin
      return Ada.Strings.Unbounded.To_String (Object.Get_Summary);
   end Get_Summary;
   function Get_Summary (Object : in Post_Ref)
                  return Ada.Strings.Unbounded.Unbounded_String is
      Impl : constant Post_Access
         := Post_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Summary;
   end Get_Summary;


   procedure Set_Format (Object : in out Post_Ref;
                         Value  : in AWA.Blogs.Models.Format_Type) is
      procedure Set_Field_Enum is
         new ADO.Audits.Set_Field_Operation (Format_Type,
                                             Format_Type_Objects.To_Object);
      Impl : Post_Access;
   begin
      Set_Field (Object, Impl);
      Set_Field_Enum (Impl.all, 12, Impl.Format, Value);
   end Set_Format;

   function Get_Format (Object : in Post_Ref)
                  return AWA.Blogs.Models.Format_Type is
      Impl : constant Post_Access
         := Post_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Format;
   end Get_Format;


   procedure Set_Author (Object : in out Post_Ref;
                         Value  : in AWA.Users.Models.User_Ref'Class) is
      Impl : Post_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_Object (Impl.all, 13, Impl.Author, Value);
   end Set_Author;

   function Get_Author (Object : in Post_Ref)
                  return AWA.Users.Models.User_Ref'Class is
      Impl : constant Post_Access
         := Post_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Author;
   end Get_Author;


   procedure Set_Blog (Object : in out Post_Ref;
                       Value  : in AWA.Blogs.Models.Blog_Ref'Class) is
      Impl : Post_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_Object (Impl.all, 14, Impl.Blog, Value);
   end Set_Blog;

   function Get_Blog (Object : in Post_Ref)
                  return AWA.Blogs.Models.Blog_Ref'Class is
      Impl : constant Post_Access
         := Post_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Blog;
   end Get_Blog;


   procedure Set_Image (Object : in out Post_Ref;
                        Value  : in AWA.Images.Models.Image_Ref'Class) is
      Impl : Post_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_Object (Impl.all, 15, Impl.Image, Value);
   end Set_Image;

   function Get_Image (Object : in Post_Ref)
                  return AWA.Images.Models.Image_Ref'Class is
      Impl : constant Post_Access
         := Post_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Image;
   end Get_Image;

   --  Copy of the object.
   procedure Copy (Object : in Post_Ref;
                   Into   : in out Post_Ref) is
      Result : Post_Ref;
   begin
      if not Object.Is_Null then
         declare
            Impl : constant Post_Access
              := Post_Impl (Object.Get_Load_Object.all)'Access;
            Copy : constant Post_Access
              := new Post_Impl;
         begin
            ADO.Objects.Set_Object (Result, Copy.all'Access);
            Copy.Copy (Impl.all);
            Copy.Title := Impl.Title;
            Copy.Text := Impl.Text;
            Copy.Create_Date := Impl.Create_Date;
            Copy.Uri := Impl.Uri;
            Copy.Version := Impl.Version;
            Copy.Publish_Date := Impl.Publish_Date;
            Copy.Status := Impl.Status;
            Copy.Allow_Comments := Impl.Allow_Comments;
            Copy.Read_Count := Impl.Read_Count;
            Copy.Summary := Impl.Summary;
            Copy.Format := Impl.Format;
            Copy.Author := Impl.Author;
            Copy.Blog := Impl.Blog;
            Copy.Image := Impl.Image;
         end;
      end if;
      Into := Result;
   end Copy;

   procedure Find (Object  : in out Post_Ref;
                   Session : in out ADO.Sessions.Session'Class;
                   Query   : in ADO.SQL.Query'Class;
                   Found   : out Boolean) is
      Impl  : constant Post_Access := new Post_Impl;
   begin
      Impl.Find (Session, Query, Found);
      if Found then
         ADO.Objects.Set_Object (Object, Impl.all'Access);
      else
         ADO.Objects.Set_Object (Object, null);
         Destroy (Impl);
      end if;
   end Find;

   procedure Load (Object  : in out Post_Ref;
                   Session : in out ADO.Sessions.Session'Class;
                   Id      : in ADO.Identifier) is
      Impl  : constant Post_Access := new Post_Impl;
      Found : Boolean;
      Query : ADO.SQL.Query;
   begin
      Query.Bind_Param (Position => 1, Value => Id);
      Query.Set_Filter ("id = ?");
      Impl.Find (Session, Query, Found);
      if not Found then
         Destroy (Impl);
         raise ADO.Objects.NOT_FOUND;
      end if;
      ADO.Objects.Set_Object (Object, Impl.all'Access);
   end Load;

   procedure Load (Object  : in out Post_Ref;
                   Session : in out ADO.Sessions.Session'Class;
                   Id      : in ADO.Identifier;
                   Found   : out Boolean) is
      Impl  : constant Post_Access := new Post_Impl;
      Query : ADO.SQL.Query;
   begin
      Query.Bind_Param (Position => 1, Value => Id);
      Query.Set_Filter ("id = ?");
      Impl.Find (Session, Query, Found);
      if not Found then
         Destroy (Impl);
      else
         ADO.Objects.Set_Object (Object, Impl.all'Access);
      end if;
   end Load;

   procedure Save (Object  : in out Post_Ref;
                   Session : in out ADO.Sessions.Master_Session'Class) is
      Impl : ADO.Objects.Object_Record_Access := Object.Get_Object;
   begin
      if Impl = null then
         Impl := new Post_Impl;
         ADO.Objects.Set_Object (Object, Impl);
      end if;
      if not ADO.Objects.Is_Created (Impl.all) then
         Impl.Create (Session);
      else
         Impl.Save (Session);
      end if;
   end Save;

   procedure Delete (Object  : in out Post_Ref;
                     Session : in out ADO.Sessions.Master_Session'Class) is
      Impl : constant ADO.Objects.Object_Record_Access := Object.Get_Object;
   begin
      if Impl /= null then
         Impl.Delete (Session);
      end if;
   end Delete;

   --  --------------------
   --  Free the object
   --  --------------------
   procedure Destroy (Object : access Post_Impl) is
      type Post_Impl_Ptr is access all Post_Impl;
      procedure Unchecked_Free is new Ada.Unchecked_Deallocation
              (Post_Impl, Post_Impl_Ptr);
      pragma Warnings (Off, "*redundant conversion*");
      Ptr : Post_Impl_Ptr := Post_Impl (Object.all)'Access;
      pragma Warnings (On, "*redundant conversion*");
   begin
      Unchecked_Free (Ptr);
   end Destroy;

   procedure Find (Object  : in out Post_Impl;
                   Session : in out ADO.Sessions.Session'Class;
                   Query   : in ADO.SQL.Query'Class;
                   Found   : out Boolean) is
      Stmt : ADO.Statements.Query_Statement
          := Session.Create_Statement (Query, POST_DEF'Access);
   begin
      Stmt.Execute;
      if Stmt.Has_Elements then
         Object.Load (Stmt, Session);
         Stmt.Next;
         Found := not Stmt.Has_Elements;
      else
         Found := False;
      end if;
   end Find;

   overriding
   procedure Load (Object  : in out Post_Impl;
                   Session : in out ADO.Sessions.Session'Class) is
      Found : Boolean;
      Query : ADO.SQL.Query;
      Id    : constant ADO.Identifier := Object.Get_Key_Value;
   begin
      Query.Bind_Param (Position => 1, Value => Id);
      Query.Set_Filter ("id = ?");
      Object.Find (Session, Query, Found);
      if not Found then
         raise ADO.Objects.NOT_FOUND;
      end if;
   end Load;

   procedure Save (Object  : in out Post_Impl;
                   Session : in out ADO.Sessions.Master_Session'Class) is
      Stmt : ADO.Statements.Update_Statement
         := Session.Create_Statement (POST_DEF'Access);
   begin
      if Object.Is_Modified (1) then
         Stmt.Save_Field (Name  => COL_0_2_NAME, --  id
                          Value => Object.Get_Key);
         Object.Clear_Modified (1);
      end if;
      if Object.Is_Modified (2) then
         Stmt.Save_Field (Name  => COL_1_2_NAME, --  title
                          Value => Object.Title);
         Object.Clear_Modified (2);
      end if;
      if Object.Is_Modified (3) then
         Stmt.Save_Field (Name  => COL_2_2_NAME, --  text
                          Value => Object.Text);
         Object.Clear_Modified (3);
      end if;
      if Object.Is_Modified (4) then
         Stmt.Save_Field (Name  => COL_3_2_NAME, --  create_date
                          Value => Object.Create_Date);
         Object.Clear_Modified (4);
      end if;
      if Object.Is_Modified (5) then
         Stmt.Save_Field (Name  => COL_4_2_NAME, --  uri
                          Value => Object.Uri);
         Object.Clear_Modified (5);
      end if;
      if Object.Is_Modified (7) then
         Stmt.Save_Field (Name  => COL_6_2_NAME, --  publish_date
                          Value => Object.Publish_Date);
         Object.Clear_Modified (7);
      end if;
      if Object.Is_Modified (8) then
         Stmt.Save_Field (Name  => COL_7_2_NAME, --  status
                          Value => Integer (Post_Status_Type'Pos (Object.Status)));
         Object.Clear_Modified (8);
      end if;
      if Object.Is_Modified (9) then
         Stmt.Save_Field (Name  => COL_8_2_NAME, --  allow_comments
                          Value => Object.Allow_Comments);
         Object.Clear_Modified (9);
      end if;
      if Object.Is_Modified (10) then
         Stmt.Save_Field (Name  => COL_9_2_NAME, --  read_count
                          Value => Object.Read_Count);
         Object.Clear_Modified (10);
      end if;
      if Object.Is_Modified (11) then
         Stmt.Save_Field (Name  => COL_10_2_NAME, --  summary
                          Value => Object.Summary);
         Object.Clear_Modified (11);
      end if;
      if Object.Is_Modified (12) then
         Stmt.Save_Field (Name  => COL_11_2_NAME, --  format
                          Value => Integer (Format_Type'Pos (Object.Format)));
         Object.Clear_Modified (12);
      end if;
      if Object.Is_Modified (13) then
         Stmt.Save_Field (Name  => COL_12_2_NAME, --  author_id
                          Value => Object.Author);
         Object.Clear_Modified (13);
      end if;
      if Object.Is_Modified (14) then
         Stmt.Save_Field (Name  => COL_13_2_NAME, --  blog_id
                          Value => Object.Blog);
         Object.Clear_Modified (14);
      end if;
      if Object.Is_Modified (15) then
         Stmt.Save_Field (Name  => COL_14_2_NAME, --  image_id
                          Value => Object.Image);
         Object.Clear_Modified (15);
      end if;
      if Stmt.Has_Save_Fields then
         Object.Version := Object.Version + 1;
         Stmt.Save_Field (Name  => "version",
                          Value => Object.Version);
         Stmt.Set_Filter (Filter => "id = ? and version = ?");
         Stmt.Add_Param (Value => Object.Get_Key);
         Stmt.Add_Param (Value => Object.Version - 1);
         declare
            Result : Integer;
         begin
            Stmt.Execute (Result);
            if Result /= 1 then
               if Result /= 0 then
                  raise ADO.Objects.UPDATE_ERROR;
               else
                  raise ADO.Objects.LAZY_LOCK;
               end if;
            end if;
            ADO.Audits.Save (Object, Session);
         end;
      end if;
   end Save;

   procedure Create (Object  : in out Post_Impl;
                     Session : in out ADO.Sessions.Master_Session'Class) is
      Query : ADO.Statements.Insert_Statement
                  := Session.Create_Statement (POST_DEF'Access);
      Result : Integer;
   begin
      Object.Version := 1;
      Session.Allocate (Id => Object);
      Query.Save_Field (Name  => COL_0_2_NAME, --  id
                        Value => Object.Get_Key);
      Query.Save_Field (Name  => COL_1_2_NAME, --  title
                        Value => Object.Title);
      Query.Save_Field (Name  => COL_2_2_NAME, --  text
                        Value => Object.Text);
      Query.Save_Field (Name  => COL_3_2_NAME, --  create_date
                        Value => Object.Create_Date);
      Query.Save_Field (Name  => COL_4_2_NAME, --  uri
                        Value => Object.Uri);
      Query.Save_Field (Name  => COL_5_2_NAME, --  version
                        Value => Object.Version);
      Query.Save_Field (Name  => COL_6_2_NAME, --  publish_date
                        Value => Object.Publish_Date);
      Query.Save_Field (Name  => COL_7_2_NAME, --  status
                        Value => Integer (Post_Status_Type'Pos (Object.Status)));
      Query.Save_Field (Name  => COL_8_2_NAME, --  allow_comments
                        Value => Object.Allow_Comments);
      Query.Save_Field (Name  => COL_9_2_NAME, --  read_count
                        Value => Object.Read_Count);
      Query.Save_Field (Name  => COL_10_2_NAME, --  summary
                        Value => Object.Summary);
      Query.Save_Field (Name  => COL_11_2_NAME, --  format
                        Value => Integer (Format_Type'Pos (Object.Format)));
      Query.Save_Field (Name  => COL_12_2_NAME, --  author_id
                        Value => Object.Author);
      Query.Save_Field (Name  => COL_13_2_NAME, --  blog_id
                        Value => Object.Blog);
      Query.Save_Field (Name  => COL_14_2_NAME, --  image_id
                        Value => Object.Image);
      Query.Execute (Result);
      if Result /= 1 then
         raise ADO.Objects.INSERT_ERROR;
      end if;
      ADO.Objects.Set_Created (Object);
      ADO.Audits.Save (Object, Session);
   end Create;

   procedure Delete (Object  : in out Post_Impl;
                     Session : in out ADO.Sessions.Master_Session'Class) is
      Stmt : ADO.Statements.Delete_Statement
         := Session.Create_Statement (POST_DEF'Access);
   begin
      Stmt.Set_Filter (Filter => "id = ?");
      Stmt.Add_Param (Value => Object.Get_Key);
      Stmt.Execute;
   end Delete;

   --  ------------------------------
   --  Get the bean attribute identified by the name.
   --  ------------------------------
   overriding
   function Get_Value (From : in Post_Ref;
                       Name : in String) return Util.Beans.Objects.Object is
      Obj  : ADO.Objects.Object_Record_Access;
      Impl : access Post_Impl;
   begin
      if From.Is_Null then
         return Util.Beans.Objects.Null_Object;
      end if;
      Obj := From.Get_Load_Object;
      Impl := Post_Impl (Obj.all)'Access;
      if Name = "id" then
         return ADO.Objects.To_Object (Impl.Get_Key);
      elsif Name = "title" then
         return Util.Beans.Objects.To_Object (Impl.Title);
      elsif Name = "text" then
         return Util.Beans.Objects.To_Object (Impl.Text);
      elsif Name = "create_date" then
         return Util.Beans.Objects.Time.To_Object (Impl.Create_Date);
      elsif Name = "uri" then
         return Util.Beans.Objects.To_Object (Impl.Uri);
      elsif Name = "publish_date" then
         if Impl.Publish_Date.Is_Null then
            return Util.Beans.Objects.Null_Object;
         else
            return Util.Beans.Objects.Time.To_Object (Impl.Publish_Date.Value);
         end if;
      elsif Name = "status" then
         return AWA.Blogs.Models.Post_Status_Type_Objects.To_Object (Impl.Status);
      elsif Name = "allow_comments" then
         return Util.Beans.Objects.To_Object (Impl.Allow_Comments);
      elsif Name = "read_count" then
         return Util.Beans.Objects.To_Object (Long_Long_Integer (Impl.Read_Count));
      elsif Name = "summary" then
         return Util.Beans.Objects.To_Object (Impl.Summary);
      elsif Name = "format" then
         return AWA.Blogs.Models.Format_Type_Objects.To_Object (Impl.Format);
      end if;
      return Util.Beans.Objects.Null_Object;
   end Get_Value;



   --  ------------------------------
   --  Load the object from current iterator position
   --  ------------------------------
   procedure Load (Object  : in out Post_Impl;
                   Stmt    : in out ADO.Statements.Query_Statement'Class;
                   Session : in out ADO.Sessions.Session'Class) is
   begin
      Object.Set_Key_Value (Stmt.Get_Identifier (0));
      Object.Title := Stmt.Get_Unbounded_String (1);
      Object.Text := Stmt.Get_Unbounded_String (2);
      Object.Create_Date := Stmt.Get_Time (3);
      Object.Uri := Stmt.Get_Unbounded_String (4);
      Object.Publish_Date := Stmt.Get_Nullable_Time (6);
      Object.Status := Post_Status_Type'Val (Stmt.Get_Integer (7));
      Object.Allow_Comments := Stmt.Get_Boolean (8);
      Object.Read_Count := Stmt.Get_Integer (9);
      Object.Summary := Stmt.Get_Unbounded_String (10);
      Object.Format := Format_Type'Val (Stmt.Get_Integer (11));
      if not Stmt.Is_Null (12) then
         Object.Author.Set_Key_Value (Stmt.Get_Identifier (12), Session);
      end if;
      if not Stmt.Is_Null (13) then
         Object.Blog.Set_Key_Value (Stmt.Get_Identifier (13), Session);
      end if;
      if not Stmt.Is_Null (14) then
         Object.Image.Set_Key_Value (Stmt.Get_Identifier (14), Session);
      end if;
      Object.Version := Stmt.Get_Integer (5);
      ADO.Objects.Set_Created (Object);
   end Load;


   --  ------------------------------
   --  Get the bean attribute identified by the name.
   --  ------------------------------
   overriding
   function Get_Value (From : in Admin_Post_Info;
                       Name : in String) return Util.Beans.Objects.Object is
   begin
      if Name = "id" then
         return Util.Beans.Objects.To_Object (Long_Long_Integer (From.Id));
      elsif Name = "title" then
         return Util.Beans.Objects.To_Object (From.Title);
      elsif Name = "uri" then
         return Util.Beans.Objects.To_Object (From.Uri);
      elsif Name = "date" then
         return Util.Beans.Objects.Time.To_Object (From.Date);
      elsif Name = "status" then
         return AWA.Blogs.Models.Post_Status_Type_Objects.To_Object (From.Status);
      elsif Name = "read_count" then
         return Util.Beans.Objects.To_Object (Long_Long_Integer (From.Read_Count));
      elsif Name = "username" then
         return Util.Beans.Objects.To_Object (From.Username);
      elsif Name = "comment_count" then
         return Util.Beans.Objects.To_Object (Long_Long_Integer (From.Comment_Count));
      end if;
      return Util.Beans.Objects.Null_Object;
   end Get_Value;


   --  ------------------------------
   --  Set the value identified by the name
   --  ------------------------------
   overriding
   procedure Set_Value (Item  : in out Admin_Post_Info;
                        Name  : in String;
                        Value : in Util.Beans.Objects.Object) is
   begin
      if Name = "id" then
         Item.Id := ADO.Identifier (Util.Beans.Objects.To_Long_Long_Integer (Value));
      elsif Name = "title" then
         Item.Title := Util.Beans.Objects.To_Unbounded_String (Value);
      elsif Name = "uri" then
         Item.Uri := Util.Beans.Objects.To_Unbounded_String (Value);
      elsif Name = "date" then
         Item.Date := Util.Beans.Objects.Time.To_Time (Value);
      elsif Name = "status" then
         Item.Status := AWA.Blogs.Models.Post_Status_Type_Objects.To_Value (Value);
      elsif Name = "read_count" then
         Item.Read_Count := Util.Beans.Objects.To_Integer (Value);
      elsif Name = "username" then
         Item.Username := Util.Beans.Objects.To_Unbounded_String (Value);
      elsif Name = "comment_count" then
         Item.Comment_Count := Util.Beans.Objects.To_Integer (Value);
      end if;
   end Set_Value;


   --  --------------------
   --  Run the query controlled by <b>Context</b> and append the list in <b>Object</b>.
   --  --------------------
   procedure List (Object  : in out Admin_Post_Info_List_Bean'Class;
                   Session : in out ADO.Sessions.Session'Class;
                   Context : in out ADO.Queries.Context'Class) is
   begin
      List (Object.List, Session, Context);
   end List;

   --  --------------------
   --  The Admin_Post_Info describes a post in the administration interface.
   --  --------------------
   procedure List (Object  : in out Admin_Post_Info_Vector;
                   Session : in out ADO.Sessions.Session'Class;
                   Context : in out ADO.Queries.Context'Class) is
      procedure Read (Into : in out Admin_Post_Info);

      Stmt : ADO.Statements.Query_Statement
          := Session.Create_Statement (Context);
      Pos  : Positive := 1;
      procedure Read (Into : in out Admin_Post_Info) is
      begin
         Into.Id := Stmt.Get_Identifier (0);
         Into.Title := Stmt.Get_Unbounded_String (1);
         Into.Uri := Stmt.Get_Unbounded_String (2);
         Into.Date := Stmt.Get_Time (3);
         Into.Status := AWA.Blogs.Models.Post_Status_Type'Val (Stmt.Get_Integer (4));
         Into.Read_Count := Stmt.Get_Natural (5);
         Into.Username := Stmt.Get_Unbounded_String (6);
         Into.Comment_Count := Stmt.Get_Natural (7);
      end Read;
   begin
      Stmt.Execute;
      Admin_Post_Info_Vectors.Clear (Object);
      while Stmt.Has_Elements loop
         Object.Insert_Space (Before => Pos);
         Object.Update_Element (Index => Pos, Process => Read'Access);
         Pos := Pos + 1;
         Stmt.Next;
      end loop;
   end List;



   --  ------------------------------
   --  Get the bean attribute identified by the name.
   --  ------------------------------
   overriding
   function Get_Value (From : in Blog_Info;
                       Name : in String) return Util.Beans.Objects.Object is
   begin
      if Name = "id" then
         return Util.Beans.Objects.To_Object (Long_Long_Integer (From.Id));
      elsif Name = "title" then
         return Util.Beans.Objects.To_Object (From.Title);
      elsif Name = "uid" then
         return Util.Beans.Objects.To_Object (From.Uid);
      elsif Name = "create_date" then
         return Util.Beans.Objects.Time.To_Object (From.Create_Date);
      elsif Name = "post_count" then
         return Util.Beans.Objects.To_Object (Long_Long_Integer (From.Post_Count));
      end if;
      return Util.Beans.Objects.Null_Object;
   end Get_Value;


   --  ------------------------------
   --  Set the value identified by the name
   --  ------------------------------
   overriding
   procedure Set_Value (Item  : in out Blog_Info;
                        Name  : in String;
                        Value : in Util.Beans.Objects.Object) is
   begin
      if Name = "id" then
         Item.Id := ADO.Identifier (Util.Beans.Objects.To_Long_Long_Integer (Value));
      elsif Name = "title" then
         Item.Title := Util.Beans.Objects.To_Unbounded_String (Value);
      elsif Name = "uid" then
         Item.Uid := Util.Beans.Objects.To_Unbounded_String (Value);
      elsif Name = "create_date" then
         Item.Create_Date := Util.Beans.Objects.Time.To_Time (Value);
      elsif Name = "post_count" then
         Item.Post_Count := Util.Beans.Objects.To_Integer (Value);
      end if;
   end Set_Value;


   --  --------------------
   --  Run the query controlled by <b>Context</b> and append the list in <b>Object</b>.
   --  --------------------
   procedure List (Object  : in out Blog_Info_List_Bean'Class;
                   Session : in out ADO.Sessions.Session'Class;
                   Context : in out ADO.Queries.Context'Class) is
   begin
      List (Object.List, Session, Context);
   end List;

   --  --------------------
   --  The list of blogs.
   --  --------------------
   procedure List (Object  : in out Blog_Info_Vector;
                   Session : in out ADO.Sessions.Session'Class;
                   Context : in out ADO.Queries.Context'Class) is
      procedure Read (Into : in out Blog_Info);

      Stmt : ADO.Statements.Query_Statement
          := Session.Create_Statement (Context);
      Pos  : Positive := 1;
      procedure Read (Into : in out Blog_Info) is
      begin
         Into.Id := Stmt.Get_Identifier (0);
         Into.Title := Stmt.Get_Unbounded_String (1);
         Into.Uid := Stmt.Get_Unbounded_String (2);
         Into.Create_Date := Stmt.Get_Time (3);
         Into.Post_Count := Stmt.Get_Integer (4);
      end Read;
   begin
      Stmt.Execute;
      Blog_Info_Vectors.Clear (Object);
      while Stmt.Has_Elements loop
         Object.Insert_Space (Before => Pos);
         Object.Update_Element (Index => Pos, Process => Read'Access);
         Pos := Pos + 1;
         Stmt.Next;
      end loop;
   end List;



   --  ------------------------------
   --  Get the bean attribute identified by the name.
   --  ------------------------------
   overriding
   function Get_Value (From : in Comment_Info;
                       Name : in String) return Util.Beans.Objects.Object is
   begin
      if Name = "id" then
         return Util.Beans.Objects.To_Object (Long_Long_Integer (From.Id));
      elsif Name = "post_id" then
         return Util.Beans.Objects.To_Object (Long_Long_Integer (From.Post_Id));
      elsif Name = "title" then
         return Util.Beans.Objects.To_Object (From.Title);
      elsif Name = "author" then
         return Util.Beans.Objects.To_Object (From.Author);
      elsif Name = "email" then
         return Util.Beans.Objects.To_Object (From.Email);
      elsif Name = "date" then
         return Util.Beans.Objects.Time.To_Object (From.Date);
      elsif Name = "status" then
         return AWA.Comments.Models.Status_Type_Objects.To_Object (From.Status);
      end if;
      return Util.Beans.Objects.Null_Object;
   end Get_Value;


   --  ------------------------------
   --  Set the value identified by the name
   --  ------------------------------
   overriding
   procedure Set_Value (Item  : in out Comment_Info;
                        Name  : in String;
                        Value : in Util.Beans.Objects.Object) is
   begin
      if Name = "id" then
         Item.Id := ADO.Identifier (Util.Beans.Objects.To_Long_Long_Integer (Value));
      elsif Name = "post_id" then
         Item.Post_Id := ADO.Identifier (Util.Beans.Objects.To_Long_Long_Integer (Value));
      elsif Name = "title" then
         Item.Title := Util.Beans.Objects.To_Unbounded_String (Value);
      elsif Name = "author" then
         Item.Author := Util.Beans.Objects.To_Unbounded_String (Value);
      elsif Name = "email" then
         Item.Email := Util.Beans.Objects.To_Unbounded_String (Value);
      elsif Name = "date" then
         Item.Date := Util.Beans.Objects.Time.To_Time (Value);
      elsif Name = "status" then
         Item.Status := AWA.Comments.Models.Status_Type_Objects.To_Value (Value);
      end if;
   end Set_Value;


   --  --------------------
   --  Run the query controlled by <b>Context</b> and append the list in <b>Object</b>.
   --  --------------------
   procedure List (Object  : in out Comment_Info_List_Bean'Class;
                   Session : in out ADO.Sessions.Session'Class;
                   Context : in out ADO.Queries.Context'Class) is
   begin
      List (Object.List, Session, Context);
   end List;

   --  --------------------
   --  The comment information.
   --  --------------------
   procedure List (Object  : in out Comment_Info_Vector;
                   Session : in out ADO.Sessions.Session'Class;
                   Context : in out ADO.Queries.Context'Class) is
      procedure Read (Into : in out Comment_Info);

      Stmt : ADO.Statements.Query_Statement
          := Session.Create_Statement (Context);
      Pos  : Positive := 1;
      procedure Read (Into : in out Comment_Info) is
      begin
         Into.Id := Stmt.Get_Identifier (0);
         Into.Post_Id := Stmt.Get_Identifier (1);
         Into.Title := Stmt.Get_Unbounded_String (2);
         Into.Author := Stmt.Get_Unbounded_String (3);
         Into.Email := Stmt.Get_Unbounded_String (4);
         Into.Date := Stmt.Get_Time (5);
         Into.Status := AWA.Comments.Models.Status_Type'Val (Stmt.Get_Integer (6));
      end Read;
   begin
      Stmt.Execute;
      Comment_Info_Vectors.Clear (Object);
      while Stmt.Has_Elements loop
         Object.Insert_Space (Before => Pos);
         Object.Update_Element (Index => Pos, Process => Read'Access);
         Pos := Pos + 1;
         Stmt.Next;
      end loop;
   end List;



   --  ------------------------------
   --  Get the bean attribute identified by the name.
   --  ------------------------------
   overriding
   function Get_Value (From : in Image_Info;
                       Name : in String) return Util.Beans.Objects.Object is
   begin
      if Name = "folder_id" then
         return Util.Beans.Objects.To_Object (Long_Long_Integer (From.Folder_Id));
      elsif Name = "id" then
         return Util.Beans.Objects.To_Object (Long_Long_Integer (From.Id));
      elsif Name = "create_date" then
         return Util.Beans.Objects.Time.To_Object (From.Create_Date);
      elsif Name = "uri" then
         return Util.Beans.Objects.To_Object (From.Uri);
      elsif Name = "storage" then
         return AWA.Storages.Models.Storage_Type_Objects.To_Object (From.Storage);
      elsif Name = "mime_type" then
         return Util.Beans.Objects.To_Object (From.Mime_Type);
      elsif Name = "file_size" then
         return Util.Beans.Objects.To_Object (Long_Long_Integer (From.File_Size));
      elsif Name = "width" then
         return Util.Beans.Objects.To_Object (Long_Long_Integer (From.Width));
      elsif Name = "height" then
         return Util.Beans.Objects.To_Object (Long_Long_Integer (From.Height));
      end if;
      return Util.Beans.Objects.Null_Object;
   end Get_Value;


   --  ------------------------------
   --  Set the value identified by the name
   --  ------------------------------
   overriding
   procedure Set_Value (Item  : in out Image_Info;
                        Name  : in String;
                        Value : in Util.Beans.Objects.Object) is
   begin
      if Name = "folder_id" then
         Item.Folder_Id := ADO.Identifier (Util.Beans.Objects.To_Long_Long_Integer (Value));
      elsif Name = "id" then
         Item.Id := ADO.Identifier (Util.Beans.Objects.To_Long_Long_Integer (Value));
      elsif Name = "create_date" then
         Item.Create_Date := Util.Beans.Objects.Time.To_Time (Value);
      elsif Name = "uri" then
         Item.Uri := Util.Beans.Objects.To_Unbounded_String (Value);
      elsif Name = "storage" then
         Item.Storage := AWA.Storages.Models.Storage_Type_Objects.To_Value (Value);
      elsif Name = "mime_type" then
         Item.Mime_Type := Util.Beans.Objects.To_Unbounded_String (Value);
      elsif Name = "file_size" then
         Item.File_Size := Util.Beans.Objects.To_Integer (Value);
      elsif Name = "width" then
         Item.Width := Util.Beans.Objects.To_Integer (Value);
      elsif Name = "height" then
         Item.Height := Util.Beans.Objects.To_Integer (Value);
      end if;
   end Set_Value;


   --  --------------------
   --  Run the query controlled by <b>Context</b> and append the list in <b>Object</b>.
   --  --------------------
   procedure List (Object  : in out Image_Info_List_Bean'Class;
                   Session : in out ADO.Sessions.Session'Class;
                   Context : in out ADO.Queries.Context'Class) is
   begin
      List (Object.List, Session, Context);
   end List;

   --  --------------------
   --  The information about an image used in a wiki page.
   --  --------------------
   procedure List (Object  : in out Image_Info_Vector;
                   Session : in out ADO.Sessions.Session'Class;
                   Context : in out ADO.Queries.Context'Class) is
      procedure Read (Into : in out Image_Info);

      Stmt : ADO.Statements.Query_Statement
          := Session.Create_Statement (Context);
      Pos  : Positive := 1;
      procedure Read (Into : in out Image_Info) is
      begin
         Into.Folder_Id := Stmt.Get_Identifier (0);
         Into.Id := Stmt.Get_Identifier (1);
         Into.Create_Date := Stmt.Get_Time (2);
         Into.Uri := Stmt.Get_Unbounded_String (3);
         Into.Storage := AWA.Storages.Models.Storage_Type'Val (Stmt.Get_Integer (4));
         Into.Mime_Type := Stmt.Get_Unbounded_String (5);
         Into.File_Size := Stmt.Get_Integer (6);
         Into.Width := Stmt.Get_Integer (7);
         Into.Height := Stmt.Get_Integer (8);
      end Read;
   begin
      Stmt.Execute;
      Image_Info_Vectors.Clear (Object);
      while Stmt.Has_Elements loop
         Object.Insert_Space (Before => Pos);
         Object.Update_Element (Index => Pos, Process => Read'Access);
         Pos := Pos + 1;
         Stmt.Next;
      end loop;
   end List;



   --  ------------------------------
   --  Get the bean attribute identified by the name.
   --  ------------------------------
   overriding
   function Get_Value (From : in Month_Stat_Info;
                       Name : in String) return Util.Beans.Objects.Object is
   begin
      if Name = "year" then
         return Util.Beans.Objects.To_Object (Long_Long_Integer (From.Year));
      elsif Name = "month" then
         return Util.Beans.Objects.To_Object (Long_Long_Integer (From.Month));
      elsif Name = "count" then
         return Util.Beans.Objects.To_Object (Long_Long_Integer (From.Count));
      end if;
      return Util.Beans.Objects.Null_Object;
   end Get_Value;


   --  ------------------------------
   --  Set the value identified by the name
   --  ------------------------------
   overriding
   procedure Set_Value (Item  : in out Month_Stat_Info;
                        Name  : in String;
                        Value : in Util.Beans.Objects.Object) is
   begin
      if Name = "year" then
         Item.Year := Util.Beans.Objects.To_Integer (Value);
      elsif Name = "month" then
         Item.Month := Util.Beans.Objects.To_Integer (Value);
      elsif Name = "count" then
         Item.Count := Util.Beans.Objects.To_Integer (Value);
      end if;
   end Set_Value;


   --  --------------------
   --  Run the query controlled by <b>Context</b> and append the list in <b>Object</b>.
   --  --------------------
   procedure List (Object  : in out Month_Stat_Info_List_Bean'Class;
                   Session : in out ADO.Sessions.Session'Class;
                   Context : in out ADO.Queries.Context'Class) is
   begin
      List (Object.List, Session, Context);
   end List;

   --  --------------------
   --  The month statistics.
   --  --------------------
   procedure List (Object  : in out Month_Stat_Info_Vector;
                   Session : in out ADO.Sessions.Session'Class;
                   Context : in out ADO.Queries.Context'Class) is
      procedure Read (Into : in out Month_Stat_Info);

      Stmt : ADO.Statements.Query_Statement
          := Session.Create_Statement (Context);
      Pos  : Positive := 1;
      procedure Read (Into : in out Month_Stat_Info) is
      begin
         Into.Year := Stmt.Get_Natural (0);
         Into.Month := Stmt.Get_Natural (1);
         Into.Count := Stmt.Get_Natural (2);
      end Read;
   begin
      Stmt.Execute;
      Month_Stat_Info_Vectors.Clear (Object);
      while Stmt.Has_Elements loop
         Object.Insert_Space (Before => Pos);
         Object.Update_Element (Index => Pos, Process => Read'Access);
         Pos := Pos + 1;
         Stmt.Next;
      end loop;
   end List;



   --  ------------------------------
   --  Get the bean attribute identified by the name.
   --  ------------------------------
   overriding
   function Get_Value (From : in Post_Info;
                       Name : in String) return Util.Beans.Objects.Object is
   begin
      if Name = "id" then
         return Util.Beans.Objects.To_Object (Long_Long_Integer (From.Id));
      elsif Name = "title" then
         return Util.Beans.Objects.To_Object (From.Title);
      elsif Name = "uri" then
         return Util.Beans.Objects.To_Object (From.Uri);
      elsif Name = "date" then
         return Util.Beans.Objects.Time.To_Object (From.Date);
      elsif Name = "username" then
         return Util.Beans.Objects.To_Object (From.Username);
      elsif Name = "format" then
         return AWA.Blogs.Models.Format_Type_Objects.To_Object (From.Format);
      elsif Name = "summary" then
         return Util.Beans.Objects.To_Object (From.Summary);
      elsif Name = "text" then
         return Util.Beans.Objects.To_Object (From.Text);
      elsif Name = "allow_comments" then
         return Util.Beans.Objects.To_Object (From.Allow_Comments);
      elsif Name = "comment_count" then
         return Util.Beans.Objects.To_Object (Long_Long_Integer (From.Comment_Count));
      end if;
      return Util.Beans.Objects.Null_Object;
   end Get_Value;


   --  ------------------------------
   --  Set the value identified by the name
   --  ------------------------------
   overriding
   procedure Set_Value (Item  : in out Post_Info;
                        Name  : in String;
                        Value : in Util.Beans.Objects.Object) is
   begin
      if Name = "id" then
         Item.Id := ADO.Identifier (Util.Beans.Objects.To_Long_Long_Integer (Value));
      elsif Name = "title" then
         Item.Title := Util.Beans.Objects.To_Unbounded_String (Value);
      elsif Name = "uri" then
         Item.Uri := Util.Beans.Objects.To_Unbounded_String (Value);
      elsif Name = "date" then
         Item.Date := Util.Beans.Objects.Time.To_Time (Value);
      elsif Name = "username" then
         Item.Username := Util.Beans.Objects.To_Unbounded_String (Value);
      elsif Name = "format" then
         Item.Format := AWA.Blogs.Models.Format_Type_Objects.To_Value (Value);
      elsif Name = "summary" then
         Item.Summary := Util.Beans.Objects.To_Unbounded_String (Value);
      elsif Name = "text" then
         Item.Text := Util.Beans.Objects.To_Unbounded_String (Value);
      elsif Name = "allow_comments" then
         Item.Allow_Comments := Util.Beans.Objects.To_Boolean (Value);
      elsif Name = "comment_count" then
         Item.Comment_Count := Util.Beans.Objects.To_Integer (Value);
      end if;
   end Set_Value;


   --  --------------------
   --  Run the query controlled by <b>Context</b> and append the list in <b>Object</b>.
   --  --------------------
   procedure List (Object  : in out Post_Info_List_Bean'Class;
                   Session : in out ADO.Sessions.Session'Class;
                   Context : in out ADO.Queries.Context'Class) is
   begin
      List (Object.List, Session, Context);
   end List;

   --  --------------------
   --  The Post_Info describes a post to be displayed in the blog page
   --  --------------------
   procedure List (Object  : in out Post_Info_Vector;
                   Session : in out ADO.Sessions.Session'Class;
                   Context : in out ADO.Queries.Context'Class) is
      procedure Read (Into : in out Post_Info);

      Stmt : ADO.Statements.Query_Statement
          := Session.Create_Statement (Context);
      Pos  : Positive := 1;
      procedure Read (Into : in out Post_Info) is
      begin
         Into.Id := Stmt.Get_Identifier (0);
         Into.Title := Stmt.Get_Unbounded_String (1);
         Into.Uri := Stmt.Get_Unbounded_String (2);
         Into.Date := Stmt.Get_Time (3);
         Into.Username := Stmt.Get_Unbounded_String (4);
         Into.Format := AWA.Blogs.Models.Format_Type'Val (Stmt.Get_Integer (5));
         Into.Summary := Stmt.Get_Unbounded_String (6);
         Into.Text := Stmt.Get_Unbounded_String (7);
         Into.Allow_Comments := Stmt.Get_Boolean (8);
         Into.Comment_Count := Stmt.Get_Natural (9);
      end Read;
   begin
      Stmt.Execute;
      Post_Info_Vectors.Clear (Object);
      while Stmt.Has_Elements loop
         Object.Insert_Space (Before => Pos);
         Object.Update_Element (Index => Pos, Process => Read'Access);
         Pos := Pos + 1;
         Stmt.Next;
      end loop;
   end List;


   procedure Op_Create (Bean    : in out Blog_Bean;
                        Outcome : in out Ada.Strings.Unbounded.Unbounded_String);
   procedure Op_Create (Bean    : in out Blog_Bean;
                        Outcome : in out Ada.Strings.Unbounded.Unbounded_String) is
   begin
      Blog_Bean'Class (Bean).Create (Outcome);
   end Op_Create;
   package Binding_Blog_Bean_1 is
     new ASF.Events.Faces.Actions.Action_Method.Bind (Bean   => Blog_Bean,
                                                      Method => Op_Create,
                                                      Name   => "create");
   procedure Op_Create_Default (Bean  : in out Blog_Bean;
                                Event : in AWA.Events.Module_Event'Class);
   procedure Op_Create_Default (Bean  : in out Blog_Bean;
                                Event : in AWA.Events.Module_Event'Class) is
   begin
      Blog_Bean'Class (Bean).Create_Default (Event);
   end Op_Create_Default;
   package Binding_Blog_Bean_2 is
     new AWA.Events.Action_Method.Bind (Bean   => Blog_Bean,
                                        Method => Op_Create_Default,
                                        Name   => "create_default");
   procedure Op_Load (Bean    : in out Blog_Bean;
                      Outcome : in out Ada.Strings.Unbounded.Unbounded_String);
   procedure Op_Load (Bean    : in out Blog_Bean;
                      Outcome : in out Ada.Strings.Unbounded.Unbounded_String) is
   begin
      Blog_Bean'Class (Bean).Load (Outcome);
   end Op_Load;
   package Binding_Blog_Bean_3 is
     new ASF.Events.Faces.Actions.Action_Method.Bind (Bean   => Blog_Bean,
                                                      Method => Op_Load,
                                                      Name   => "load");

   Binding_Blog_Bean_Array : aliased constant Util.Beans.Methods.Method_Binding_Array
     := (1 => Binding_Blog_Bean_1.Proxy'Access,
         2 => Binding_Blog_Bean_2.Proxy'Access,
         3 => Binding_Blog_Bean_3.Proxy'Access
     );

   --  ------------------------------
   --  This bean provides some methods that can be used in a Method_Expression.
   --  ------------------------------
   overriding
   function Get_Method_Bindings (From : in Blog_Bean)
                                 return Util.Beans.Methods.Method_Binding_Array_Access is
      pragma Unreferenced (From);
   begin
      return Binding_Blog_Bean_Array'Access;
   end Get_Method_Bindings;

   --  ------------------------------
   --  Set the value identified by the name
   --  ------------------------------
   overriding
   procedure Set_Value (Item  : in out Blog_Bean;
                        Name  : in String;
                        Value : in Util.Beans.Objects.Object) is
   begin
      if Name = "name" then
         Item.Set_Name (Util.Beans.Objects.To_String (Value));
      elsif Name = "uid" then
         Item.Set_Uid (Util.Beans.Objects.To_String (Value));
      elsif Name = "create_date" then
         Item.Set_Create_Date (Util.Beans.Objects.Time.To_Time (Value));
      elsif Name = "update_date" then
         Item.Set_Update_Date (Util.Beans.Objects.Time.To_Time (Value));
      elsif Name = "url" then
         Item.Set_Url (Util.Beans.Objects.To_String (Value));
      elsif Name = "format" then
         Item.Set_Format (Format_Type_Objects.To_Value (Value));
      elsif Name = "default_image_url" then
         Item.Set_Default_Image_Url (Util.Beans.Objects.To_String (Value));
      end if;
   end Set_Value;

   procedure Op_Save (Bean    : in out Post_Bean;
                      Outcome : in out Ada.Strings.Unbounded.Unbounded_String);
   procedure Op_Save (Bean    : in out Post_Bean;
                      Outcome : in out Ada.Strings.Unbounded.Unbounded_String) is
   begin
      Post_Bean'Class (Bean).Save (Outcome);
   end Op_Save;
   package Binding_Post_Bean_1 is
     new ASF.Events.Faces.Actions.Action_Method.Bind (Bean   => Post_Bean,
                                                      Method => Op_Save,
                                                      Name   => "save");
   procedure Op_Delete (Bean    : in out Post_Bean;
                        Outcome : in out Ada.Strings.Unbounded.Unbounded_String);
   procedure Op_Delete (Bean    : in out Post_Bean;
                        Outcome : in out Ada.Strings.Unbounded.Unbounded_String) is
   begin
      Post_Bean'Class (Bean).Delete (Outcome);
   end Op_Delete;
   package Binding_Post_Bean_2 is
     new ASF.Events.Faces.Actions.Action_Method.Bind (Bean   => Post_Bean,
                                                      Method => Op_Delete,
                                                      Name   => "delete");
   procedure Op_Load (Bean    : in out Post_Bean;
                      Outcome : in out Ada.Strings.Unbounded.Unbounded_String);
   procedure Op_Load (Bean    : in out Post_Bean;
                      Outcome : in out Ada.Strings.Unbounded.Unbounded_String) is
   begin
      Post_Bean'Class (Bean).Load (Outcome);
   end Op_Load;
   package Binding_Post_Bean_3 is
     new ASF.Events.Faces.Actions.Action_Method.Bind (Bean   => Post_Bean,
                                                      Method => Op_Load,
                                                      Name   => "load");
   procedure Op_Load_Admin (Bean    : in out Post_Bean;
                            Outcome : in out Ada.Strings.Unbounded.Unbounded_String);
   procedure Op_Load_Admin (Bean    : in out Post_Bean;
                            Outcome : in out Ada.Strings.Unbounded.Unbounded_String) is
   begin
      Post_Bean'Class (Bean).Load_Admin (Outcome);
   end Op_Load_Admin;
   package Binding_Post_Bean_4 is
     new ASF.Events.Faces.Actions.Action_Method.Bind (Bean   => Post_Bean,
                                                      Method => Op_Load_Admin,
                                                      Name   => "load_admin");
   procedure Op_Setup (Bean    : in out Post_Bean;
                       Outcome : in out Ada.Strings.Unbounded.Unbounded_String);
   procedure Op_Setup (Bean    : in out Post_Bean;
                       Outcome : in out Ada.Strings.Unbounded.Unbounded_String) is
   begin
      Post_Bean'Class (Bean).Setup (Outcome);
   end Op_Setup;
   package Binding_Post_Bean_5 is
     new ASF.Events.Faces.Actions.Action_Method.Bind (Bean   => Post_Bean,
                                                      Method => Op_Setup,
                                                      Name   => "setup");

   Binding_Post_Bean_Array : aliased constant Util.Beans.Methods.Method_Binding_Array
     := (1 => Binding_Post_Bean_1.Proxy'Access,
         2 => Binding_Post_Bean_2.Proxy'Access,
         3 => Binding_Post_Bean_3.Proxy'Access,
         4 => Binding_Post_Bean_4.Proxy'Access,
         5 => Binding_Post_Bean_5.Proxy'Access
     );

   --  ------------------------------
   --  This bean provides some methods that can be used in a Method_Expression.
   --  ------------------------------
   overriding
   function Get_Method_Bindings (From : in Post_Bean)
                                 return Util.Beans.Methods.Method_Binding_Array_Access is
      pragma Unreferenced (From);
   begin
      return Binding_Post_Bean_Array'Access;
   end Get_Method_Bindings;

   --  ------------------------------
   --  Set the value identified by the name
   --  ------------------------------
   overriding
   procedure Set_Value (Item  : in out Post_Bean;
                        Name  : in String;
                        Value : in Util.Beans.Objects.Object) is
   begin
      if Name = "title" then
         Item.Set_Title (Util.Beans.Objects.To_String (Value));
      elsif Name = "text" then
         Item.Set_Text (Util.Beans.Objects.To_String (Value));
      elsif Name = "create_date" then
         Item.Set_Create_Date (Util.Beans.Objects.Time.To_Time (Value));
      elsif Name = "uri" then
         Item.Set_Uri (Util.Beans.Objects.To_String (Value));
      elsif Name = "publish_date" then
         if Util.Beans.Objects.Is_Null (Value) then
            Item.Set_Publish_Date (ADO.Nullable_Time '(Is_Null => True, others => <>));
         else
            Item.Set_Publish_Date (ADO.Nullable_Time '(Is_Null => False,
                                        Value   => Util.Beans.Objects.Time.To_Time (Value)));
         end if;
      elsif Name = "status" then
         Item.Set_Status (Post_Status_Type_Objects.To_Value (Value));
      elsif Name = "allow_comments" then
         Item.Set_Allow_Comments (Util.Beans.Objects.To_Boolean (Value));
      elsif Name = "read_count" then
         Item.Set_Read_Count (Util.Beans.Objects.To_Integer (Value));
      elsif Name = "summary" then
         Item.Set_Summary (Util.Beans.Objects.To_String (Value));
      elsif Name = "format" then
         Item.Set_Format (Format_Type_Objects.To_Value (Value));
      end if;
   end Set_Value;

   procedure Op_Load (Bean    : in out Post_List_Bean;
                      Outcome : in out Ada.Strings.Unbounded.Unbounded_String);
   procedure Op_Load (Bean    : in out Post_List_Bean;
                      Outcome : in out Ada.Strings.Unbounded.Unbounded_String) is
   begin
      Post_List_Bean'Class (Bean).Load (Outcome);
   end Op_Load;
   package Binding_Post_List_Bean_1 is
     new ASF.Events.Faces.Actions.Action_Method.Bind (Bean   => Post_List_Bean,
                                                      Method => Op_Load,
                                                      Name   => "load");

   Binding_Post_List_Bean_Array : aliased constant Util.Beans.Methods.Method_Binding_Array
     := (1 => Binding_Post_List_Bean_1.Proxy'Access
     );

   --  ------------------------------
   --  This bean provides some methods that can be used in a Method_Expression.
   --  ------------------------------
   overriding
   function Get_Method_Bindings (From : in Post_List_Bean)
                                 return Util.Beans.Methods.Method_Binding_Array_Access is
      pragma Unreferenced (From);
   begin
      return Binding_Post_List_Bean_Array'Access;
   end Get_Method_Bindings;
   --  ------------------------------
   --  Get the bean attribute identified by the name.
   --  ------------------------------
   overriding
   function Get_Value (From : in Post_List_Bean;
                       Name : in String) return Util.Beans.Objects.Object is
   begin
      if Name = "tag" then
         return Util.Beans.Objects.To_Object (From.Tag);
      elsif Name = "page" then
         return Util.Beans.Objects.To_Object (Long_Long_Integer (From.Page));
      elsif Name = "count" then
         return Util.Beans.Objects.To_Object (Long_Long_Integer (From.Count));
      elsif Name = "page_size" then
         return Util.Beans.Objects.To_Object (Long_Long_Integer (From.Page_Size));
      end if;
      return Util.Beans.Objects.Null_Object;
   end Get_Value;


   --  ------------------------------
   --  Set the value identified by the name
   --  ------------------------------
   overriding
   procedure Set_Value (Item  : in out Post_List_Bean;
                        Name  : in String;
                        Value : in Util.Beans.Objects.Object) is
   begin
      if Name = "tag" then
         Item.Tag := Util.Beans.Objects.To_Unbounded_String (Value);
      elsif Name = "page" then
         Item.Page := Util.Beans.Objects.To_Integer (Value);
      elsif Name = "count" then
         Item.Count := Util.Beans.Objects.To_Integer (Value);
      elsif Name = "page_size" then
         Item.Page_Size := Util.Beans.Objects.To_Integer (Value);
      end if;
   end Set_Value;

   procedure Op_Load (Bean    : in out Stat_List_Bean;
                      Outcome : in out Ada.Strings.Unbounded.Unbounded_String);
   procedure Op_Load (Bean    : in out Stat_List_Bean;
                      Outcome : in out Ada.Strings.Unbounded.Unbounded_String) is
   begin
      Stat_List_Bean'Class (Bean).Load (Outcome);
   end Op_Load;
   package Binding_Stat_List_Bean_1 is
     new ASF.Events.Faces.Actions.Action_Method.Bind (Bean   => Stat_List_Bean,
                                                      Method => Op_Load,
                                                      Name   => "load");

   Binding_Stat_List_Bean_Array : aliased constant Util.Beans.Methods.Method_Binding_Array
     := (1 => Binding_Stat_List_Bean_1.Proxy'Access
     );

   --  ------------------------------
   --  This bean provides some methods that can be used in a Method_Expression.
   --  ------------------------------
   overriding
   function Get_Method_Bindings (From : in Stat_List_Bean)
                                 return Util.Beans.Methods.Method_Binding_Array_Access is
      pragma Unreferenced (From);
   begin
      return Binding_Stat_List_Bean_Array'Access;
   end Get_Method_Bindings;
   --  ------------------------------
   --  Get the bean attribute identified by the name.
   --  ------------------------------
   overriding
   function Get_Value (From : in Stat_List_Bean;
                       Name : in String) return Util.Beans.Objects.Object is
   begin
      if Name = "blog_id" then
         return Util.Beans.Objects.To_Object (Long_Long_Integer (From.Blog_Id));
      elsif Name = "post_id" then
         return Util.Beans.Objects.To_Object (Long_Long_Integer (From.Post_Id));
      end if;
      return Util.Beans.Objects.Null_Object;
   end Get_Value;


   --  ------------------------------
   --  Set the value identified by the name
   --  ------------------------------
   overriding
   procedure Set_Value (Item  : in out Stat_List_Bean;
                        Name  : in String;
                        Value : in Util.Beans.Objects.Object) is
   begin
      if Name = "blog_id" then
         Item.Blog_Id := ADO.Identifier (Util.Beans.Objects.To_Long_Long_Integer (Value));
      elsif Name = "post_id" then
         Item.Post_Id := ADO.Identifier (Util.Beans.Objects.To_Long_Long_Integer (Value));
      end if;
   end Set_Value;


end AWA.Blogs.Models;
